(* $Id: unatural.mli,v 1.7 2014/02/27 16:36:36 fclement Exp $ *)

type natural = private int
(** The private type of natural integers. *)
;;

val make : int -> natural
;;

external from : natural -> int = "%identity"
;;

val natural_of_char : char -> natural
;;

val char_of_natural : natural -> char
;;

val natural_of_int : int -> natural
;;

val int_of_natural : natural -> int
;;

val natural_of_float : float -> natural
;;

val float_of_natural : natural -> float
;;

val natural_of_string : string -> natural
;;

val string_of_natural : natural -> string
;;

val zero : natural;;
val one : natural;;
val two : natural;;

val _0_ : natural;;
val _1_ : natural;;
val _2_ : natural;;
val _3_ : natural;;
val _4_ : natural;;
val _5_ : natural;;
val _6_ : natural;;
val _7_ : natural;;
val _8_ : natural;;
val _9_ : natural;;

val ( + ) : natural -> natural -> natural;;
val ( - ) : natural -> natural -> natural;;
val ( * ) : natural -> natural -> natural;;
val ( / ) : natural -> natural -> natural;;
val succ : natural -> natural;;
val pred : natural -> natural;;

val ( = ) : natural -> natural -> bool;;
val ( <> ) : natural -> natural -> bool;;
val ( <= ) : natural -> natural -> bool;;

val is_zero : natural -> bool;;
val is_odd : natural -> bool;;
val is_even : natural -> bool;;

type t = natural;;
