/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*               EPI Pomdapi, INRIA Paris - Rocquencourt               */
/*                                                                     */
/*  Copyright 2005-2014 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: receive_communication.cpp,v 1.9 2014/01/10 19:22:09 fclement Exp $ */

#include "receive_communication.hpp"

namespace io{
  //sub-routine defined in receive.cpp:
  void r_check(istream& ib,string f,char c);

  Communication receive_communication(istream& ib){
    string f1 = "communication reception";
    r_check(ib,f1,'(');
    //recevoir le type:
    string type;
    ib>>type;
    Communication com(type);
    r_check(ib,f1,'<');
    int n;
    ib>>n;
    r_check(ib,f1,'>');
    if(type == "%t" || type == "%s"){
      string opt;
      ib>>opt;
      if(opt[0] != '\"' || opt[opt.size()-1] != '\"'){
        cerr<<"Error: invalid task or service string"<<endl;
        exit(1);
      }
      opt.erase(opt.size()-1,1);
      opt.erase(0,1);
      if(type == "%t")
        com.to_task()=Task(opt,n);
      else
        com.to_service()=Service(opt);
    } 
    if(type != "%t")
      for(int nn=0;nn<n;nn++){
        com.add(receive(ib));
      }
    else{
      vector<Typed_value> ARGS(n);
      for(int nn=0;nn<n;nn++){
        ARGS[nn] = receive(ib);
      }
      com.to_task().set_args(ARGS);
    }
    r_check(ib,f1,')');
    return com;
  } 
  
  void receive_communication(istream& ib,Communication& com){
    com=receive_communication(ib);
  }
  
  void receive(istream& ib,Communication& com){
    com=receive_communication(ib);
  }
  
  //   OTyped_value oreceive(istream& ib){
  //     string f1 = "receive Typed_value";
  //     r_begin(ib,f1);
  //     string fmt=receive_type_for_typed_value(ib);
  //     if(fmt.data()[0]=='%' || fmt.data()[0]=='('){
  //       //Typed_value p(receive_scalar_typed_value(ib,fmt));
  //       if(fmt=="%i"){
  //         int i;receive(ib,i);Int j(i);OLexem<Int> p(j);
  //         r_end(ib,f1);
  //         return p;
  //       }
  //       else if(fmt=="%f"){
  //         double i;receive(ib,i);Float f(i);OLexem<Float> p(f);
  //         r_end(ib,f1);
  //         return p;
  //       }
  //     }
  //     else if(fmt.data()[0]=='['){
  //       //Typed_value p(receive_vector_typed_value(ib,fmt));
  //       r_end(ib,f1);
  //       //return p;
  //     }
  //     else if(fmt.data()[0]=='{'){
  //       //Typed_value p(receive_matrix1_typed_value(ib,fmt));
  //       r_end(ib,f1);
  //       //return p;
  //     }
  //     else{
  //       cerr<<"wrong format "<<fmt<<" for Typed_value"<<endl;
  //       exit(1);
  //     }
  //   }
  
  
}
